<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for postConversationRequest StructType
 * @subpackage Structs
 */
class PostConversationRequest extends AbstractStructBase
{
    /**
     * The toUserNick
     * @var string
     */
    public $toUserNick;
    /**
     * The type
     * @var string
     */
    public $type;
    /**
     * The title
     * @var string
     */
    public $title;
    /**
     * The context
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\ContextDto
     */
    public $context;
    /**
     * The messageText
     * @var string
     */
    public $messageText;
    /**
     * The sendCopy
     * @var bool
     */
    public $sendCopy;
    /**
     * The lang
     * @var string
     */
    public $lang;
    /**
     * Constructor method for postConversationRequest
     * @uses PostConversationRequest::setToUserNick()
     * @uses PostConversationRequest::setType()
     * @uses PostConversationRequest::setTitle()
     * @uses PostConversationRequest::setContext()
     * @uses PostConversationRequest::setMessageText()
     * @uses PostConversationRequest::setSendCopy()
     * @uses PostConversationRequest::setLang()
     * @param string $toUserNick
     * @param string $type
     * @param string $title
     * @param \StructType\ContextDto $context
     * @param string $messageText
     * @param bool $sendCopy
     * @param string $lang
     */
    public function __construct($toUserNick = null, $type = null, $title = null, \StructType\ContextDto $context = null, $messageText = null, $sendCopy = null, $lang = null)
    {
        $this
            ->setToUserNick($toUserNick)
            ->setType($type)
            ->setTitle($title)
            ->setContext($context)
            ->setMessageText($messageText)
            ->setSendCopy($sendCopy)
            ->setLang($lang);
    }
    /**
     * Get toUserNick value
     * @return string|null
     */
    public function getToUserNick()
    {
        return $this->toUserNick;
    }
    /**
     * Set toUserNick value
     * @param string $toUserNick
     * @return \StructType\PostConversationRequest
     */
    public function setToUserNick($toUserNick = null)
    {
        // validation for constraint: string
        if (!is_null($toUserNick) && !is_string($toUserNick)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($toUserNick, true), gettype($toUserNick)), __LINE__);
        }
        $this->toUserNick = $toUserNick;
        return $this;
    }
    /**
     * Get type value
     * @return string|null
     */
    public function getType()
    {
        return $this->type;
    }
    /**
     * Set type value
     * @param string $type
     * @return \StructType\PostConversationRequest
     */
    public function setType($type = null)
    {
        // validation for constraint: string
        if (!is_null($type) && !is_string($type)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($type, true), gettype($type)), __LINE__);
        }
        $this->type = $type;
        return $this;
    }
    /**
     * Get title value
     * @return string|null
     */
    public function getTitle()
    {
        return $this->title;
    }
    /**
     * Set title value
     * @param string $title
     * @return \StructType\PostConversationRequest
     */
    public function setTitle($title = null)
    {
        // validation for constraint: string
        if (!is_null($title) && !is_string($title)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($title, true), gettype($title)), __LINE__);
        }
        $this->title = $title;
        return $this;
    }
    /**
     * Get context value
     * @return \StructType\ContextDto|null
     */
    public function getContext()
    {
        return $this->context;
    }
    /**
     * Set context value
     * @param \StructType\ContextDto $context
     * @return \StructType\PostConversationRequest
     */
    public function setContext(\StructType\ContextDto $context = null)
    {
        $this->context = $context;
        return $this;
    }
    /**
     * Get messageText value
     * @return string|null
     */
    public function getMessageText()
    {
        return $this->messageText;
    }
    /**
     * Set messageText value
     * @param string $messageText
     * @return \StructType\PostConversationRequest
     */
    public function setMessageText($messageText = null)
    {
        // validation for constraint: string
        if (!is_null($messageText) && !is_string($messageText)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($messageText, true), gettype($messageText)), __LINE__);
        }
        $this->messageText = $messageText;
        return $this;
    }
    /**
     * Get sendCopy value
     * @return bool|null
     */
    public function getSendCopy()
    {
        return $this->sendCopy;
    }
    /**
     * Set sendCopy value
     * @param bool $sendCopy
     * @return \StructType\PostConversationRequest
     */
    public function setSendCopy($sendCopy = null)
    {
        // validation for constraint: boolean
        if (!is_null($sendCopy) && !is_bool($sendCopy)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($sendCopy, true), gettype($sendCopy)), __LINE__);
        }
        $this->sendCopy = $sendCopy;
        return $this;
    }
    /**
     * Get lang value
     * @return string|null
     */
    public function getLang()
    {
        return $this->lang;
    }
    /**
     * Set lang value
     * @param string $lang
     * @return \StructType\PostConversationRequest
     */
    public function setLang($lang = null)
    {
        // validation for constraint: string
        if (!is_null($lang) && !is_string($lang)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($lang, true), gettype($lang)), __LINE__);
        }
        $this->lang = $lang;
        return $this;
    }
}
